<pre><?php

// gribu.lv exif scanner

error_log(0);
error_reporting(E_ALL);

ob_start();
ob_implicit_flush();

set_time_limit(0);
ini_set('max_execution_time', 0); // http://www.php.net/set_time_limit
ini_set('default_socket_timeout', 3);

define('HTTP_VERSION', 'HTTP/1.0');
define('NL', "\r\n");
define('DEBUG', TRUE);

$orig_dir = 'raw/';

// interactive shorcuts
function iflush() { flush(); ob_flush(); }
function iecho($str) { echo $str; iflush(); }
function idebug($str) { if (DEBUG) echo $str; iflush(); }
function ierror($str) { echo '(error: '.$str.')'; iflush(); }

// your http query o' magic
function get_remote_contents($url, $post = NULL, $timeout = 5, $maxlength = 4096) {
 $return[0] = FALSE;
 $return[1] = FALSE;

 // parse the url
 $url = parse_url($url);
 if (!isset($url['port'])) $url['port'] = 80;
 if (isset($url['query'])) $url['query'] = '?'.$url['query'];
 idebug('(host: '.$url['host'].', port: '.$url['port'].', path: '.$url['path'].', query: '.$url['query'].', timeout: '.$timeout.', maxlength: '.$maxlength.')');

 // connect
 $fp = @fsockopen($url['host'], $url['port'], $errno, $errstr, $timeout);
 if (!$fp) ierror(trim($errstr).' ('.$errno.')');
 else {
  // request fragmentation
  fwrite($fp, 'GET '.$url['path'].$url['query'].' '.HTTP_VERSION.NL);
  fwrite($fp, 'Host: '.$url['host'].NL);
  fwrite($fp, 'Connection: close'.NL);
  if ($post !== NULL) fwrite($fp, NL.$post.NL);
  else fwrite($fp, NL);
  stream_set_timeout($fp, $timeout);
  $contents = stream_get_contents($fp, $maxlength);
  $contents = split(NL.NL, $contents, 5);

  if (isset($return[0])) $return[0] = $contents[0]; // header
  if (isset($return[1])) $return[1] = $contents[1]; // data
 }

 return $return;
}

// search and extract the exif
function get_exif_thumb($file) {
 $image = @exif_thumbnail($file, $w, $h, $type);
 if ($image !== FALSE) return $image;
 else return FALSE;
}

function get_exif_data($file) {
 $exif = @exif_read_data($file, 0, true);
 if ($exif !== FALSE) return $exif;
 else return FALSE;
}

// logic
for ($i=500;$i<7500;$i++) {
 $url = 'http://www.gribu.lv/bildes/details.php?image_id='.$i;
 iecho('PP| '.$i."\t".' % fetch ');

 list($header, $data) = get_remote_contents($url);
 if ($header && $data) {
  iecho(' ok % ');
  $data = str_replace("\n", '', str_replace("\r", '', $data));

  preg_match('|<!-- Template file for JPG Files --><img src="(.*)" border="(\d+)" alt="(.*)" width="(\d+)" height="(\d+)" /><br />|U', $data, $match);
  if (isset($match[1])) {
   iecho('found ('.$match[1].') % ');
   
   $orig_name = $orig_dir.$i.'.jpg';
   $orig_info = $orig_dir.$i.'.txt';
   $orig_thumb = $orig_dir.$i.'.exif.jpg';
   if (!is_file($orig_name) && !is_file($orig_info) && !is_file($orig_thumb)) {
    $orig_image = @file_get_contents('http://www.gribu.lv/bildes/'.str_replace('./', '', $match[1]));
    if ($orig_image !== FALSE) {
     
     // save the original file to the disk
     file_put_contents($orig_name, $orig_image);
     
     // get the thumb
     $thumb = get_exif_thumb($orig_name);
     if ($thumb !== FALSE) file_put_contents($orig_thumb, $thumb);
     
     // get the photo cada
     $data = get_exif_data($orig_name);
     if ($data !== FALSE) file_put_contents($orig_info, serialize($data));
     
    } else iecho('failed'."\n");
   }
  } else iecho(' unaviable');

  iecho('done'."\n");
  unset($header); unset($data); unset($match); 
 } else iecho(' fail'."\n");
}

?></pre>